package net.cattaka.rdbassistant.sql;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class AbstractDateColumnConverter implements ColumnConverter {
	private String pattern;
	private DateFormat dateFormat;
	
	public AbstractDateColumnConverter(String pattern) {
		super();
		this.pattern = pattern;
		this.dateFormat = new SimpleDateFormat(pattern);
	}

	public Class<?> getInClass() {
		return Date.class;
	}

	public Class<?> getOutClass() {
		return String.class;
	}
	
	public int getColumnMaxCharacters() {
		return this.pattern.length();
	}

	public Object reverseConvert(Object arg) throws ConvertException {
		try {
			if (arg instanceof String) {
				return dateFormat.parse((String)arg);
			} else {
				throw new ConvertException();
			}
		} catch (ParseException e) {
			throw new ConvertException(e);
		}
	}

	public Object convert(Object arg) throws ConvertException {
		if (arg != null) {
			if (arg instanceof Date) {
				return dateFormat.format(arg);
			} else {
				throw new ConvertException();
			}
		} else {
			return null;
		}
	}

	public boolean isAvalConvert() {
		return true;
	}
	
	public boolean isAvalReverseConvert() {
		return true;
	}
}
